#include <stdio.h>
#define MAX 5

void input_matrix (int mat[][MAX], int row, int col);
void mult_matrix (int mat1[][MAX], int mat2[][MAX], int result[][MAX], int row1, int col1, int col2);
void output_matrix (int mat[][MAX], int row, int col);

main()
{
   int mat1[MAX][MAX], mat2[MAX][MAX], result[MAX][MAX];
   int row1, col1, row2, col2;
   printf("Input row & col of matrix1=> ");
   scanf ("%d %d", &row1, &col1);
   input_matrix (mat1, row1, col1);
   printf("Input row & col of matrix2 => ");
   scanf ("%d %d", &row2, &col2);
   input_matrix (mat2, row2, col2);
   mult_matrix (mat1, mat2, result, row1, col1, col2);
   output_matrix (result, row1, col2);
}

void input_matrix (int mat[][MAX], int row, int col)
{
   int i, j;
   for (i=0; i<row; i++)
      for (j=0; j<col; j++) {
         printf("Input element[%d][%d] => ", i+1, j+1);
         scanf("%d", &mat[i][j]);
      }
}

void mult_matrix (int mat1[][MAX], int mat2[][MAX], int result[][MAX], int row1, int col1, int col2)
{
   int i, j, k;
   for (i=0; i<row1; i++) {
      for (j=0; j<col2; j++) {
         result[i][j] = 0;
         for (k=0; k<col1; k++)
            result[i][j] += mat1[i][k] * mat2[k][j];
      }
   }
}

void output_matrix (int mat[][MAX], int row, int col)
{
   int i, j;
   for (i=0; i<row; i++) {
      for (j=0; j<col; j++)
         printf("%d ", mat[i][j]);
      printf("\n");
   }
}