#include <stdio.h>
#include <stdlib.h>
#define MAX_VERTICES 7

struct node {
   int data;
   struct node *next;
};
typedef struct node *node_ptr;

node_ptr table[MAX_VERTICES];
int visited[MAX_VERTICES];

node_ptr createnode (int data);
void dfs (int vertex);

main()
{
   table[0] = createnode(1);
   table[0]->next = createnode(2);
   table[0]->next->next = createnode(3);
   table[1] = createnode(0);
   table[1]->next = createnode(4);
   table[2] = createnode(0);
   table[2]->next = createnode(5);
   table[3] = createnode(0);
   table[3]->next = createnode(5);
   table[4] = createnode(1);
   table[4]->next = createnode(6);
   table[4]->next->next = createnode(5);
   table[5] = createnode(2);
   table[5]->next = createnode(3);
   table[5]->next->next = createnode(4);
   table[5]->next->next->next = createnode(6);
   table[6] = createnode(4);
   table[6]->next = createnode(5);

   dfs (0);
   printf("\n");
}

node_ptr createnode (int data)
{
   node_ptr ptr;
   ptr = (node_ptr)malloc(sizeof(struct node));
   ptr->data = data;
   ptr->next = NULL;
   return ptr;
}

void dfs (int vertex)
{
   node_ptr vertex_ptr;
   visited[vertex] = 1;
   printf ("%d ", vertex);
   for (vertex_ptr=table[vertex]; vertex_ptr; vertex_ptr= vertex_ptr->next)
      if (!visited[vertex_ptr->data])
         dfs (vertex_ptr->data);
}